-- ----------------------------------------------------------------------------
-- Miner's Coffee and Pick
-- 		by Nasapunk88
-- ----------------------------------------------------------------------------
local _, L = ...;
MCAP = {};
MCAP.debug = false;
MCAP.isDeleting = false;
MCAP.enableSwap = false;

MCAP.items = {
	{ ["name"] = "MCAP_CoffeeButton",  --"Miner's Coffee"
		["id"] = 118897, 
		["button"] = nil
	},
	{ ["name"] = "MCAP_PickButton", --"Preserved Mining Pick"
		["id"] = 118903,
		["button"] = nil
	}
};

if MCAP.debug then
	table.insert(MCAP.items,{ ["name"] = "MCAP_MilkButton", --Goats milk for testing
			["id"] = 35954,
			["button"] = nil
		});
end

function MCAP:swap()
	local bag1 = MCAP.moves[MCAP.movesNum][1][1];
	local slot1 = MCAP.moves[MCAP.movesNum][1][2];
	local bag2 = MCAP.moves[MCAP.movesNum][2][1];
	local slot2 = MCAP.moves[MCAP.movesNum][2][2];
	local num = MCAP.moves[MCAP.movesNum][3];
	local _, _, locked1 = GetContainerItemInfo(bag1, slot1)
	local _, _, locked2 = GetContainerItemInfo(bag2, slot2)
	if not locked1 and not locked2 then
		if num > 0 then
			ClearCursor()
			SplitContainerItem(bag1,slot1, num);
			PickupContainerItem(bag2,slot2);
		else
			ClearCursor()
			PickupContainerItem(bag1,slot1);
			PickupContainerItem(bag2,slot2);
		end
		MCAP.movesNum = MCAP.movesNum + 1;
	end
end

function MCAP:stack()
	local last = #MCAP.locations
	for i = 1, (#MCAP.locations - 1) do
		if i >= last then
			break;
		end
		local count = MCAP.locations[i][3];
		while count > 0 do 
			while last > 1 and MCAP.locations[last][3] == 20 do
				last = last - 1;
			end
			if i >= last then
				break;
			end
			local remaining = 20-MCAP.locations[last][3];
			if count <= remaining then
				table.insert(MCAP.moves,({{MCAP.locations[i][1], MCAP.locations[i][2]},
										 {MCAP.locations[last][1], MCAP.locations[last][2]},0}));
				MCAP.locations[last][3] = MCAP.locations[last][3] + MCAP.locations[i][3];
				MCAP.locations[i][3] = 0;
				count = 0;	
			else
				table.insert(MCAP.moves,({{MCAP.locations[i][1], MCAP.locations[i][2]},
										 {MCAP.locations[last][1], MCAP.locations[last][2]},remaining}));
				MCAP.locations[i][3] = MCAP.locations[i][3] - remaining;
				MCAP.locations[last][3] = MCAP.locations[last][3] + remaining;
				count = count - remaining;
			end
		end
	end
	MCAP.enableSwap = true;
	if next (MCAP.moves) ~= nil then
			MCAP.swap();
	end
end

function MCAP:delete(id,count,numKeep)
	MCAP.locations = {};
	MCAP.moves = {};
	MCAP.movesNum = 1;
	local numDelete = count - numKeep;
	for b = 4, 0, -1 do 
		if count == 0 then
			break;
		end
		for s = 1, GetContainerNumSlots(b) do 
			if count == 0 then
				break;
			end
			local l = GetContainerItemID(b, s)
			if l and l == id then
				local _, stackCount = GetContainerItemInfo(b, s);
				if numDelete == 0 then
					table.insert(MCAP.locations,{b,s,stackCount});
					count = count - stackCount;
				else
					if stackCount <= numDelete then
						ClearCursor();
						PickupContainerItem(b, s);
						DeleteCursorItem();
						numDelete = numDelete - stackCount;
					else
						ClearCursor();
						SplitContainerItem(b, s, numDelete);
						DeleteCursorItem();
						local newSize = stackCount-numDelete;
						table.insert(MCAP.locations,{b,s,newSize});
						numDelete = 0;
						count = numKeep-newSize;
					end
				end
			end
		end
	end
	MCAP:stack();
end
function MCAP:updateButtons()
	self.previous = 0;
	for i = 1, #self.items do
		self:updateButton(self.items[i].button,self.items[i].id,i);
	end
end

function MCAP:updateButton(btn,id,num)
	local count = GetItemCount(id);
	-- local numKeep = MinersCoffeeAndPickCharacterDB.keep[id..""];
	-- -- Delete excess items
	-- if not MCAP.isDeleting and numKeep ~= -1 and count > numKeep then
		-- MCAP.isDeleting = true;
		-- MCAP:delete(id,count,numKeep);
	-- end
	
	local name = GetItemInfo(id);
	name, _, _, buff = UnitBuff("player",name);
	--If player is missing buff
	if name == nil or (id == 118897 and buff < MinersCoffeeAndPickCharacterDB.buff ) then
		btn:Show();
		local start, duration = GetItemCooldown(id);
		btn.cooldown:SetCooldown(start, duration);
		if count > 0 then
			btn:ClearAllPoints();
			if MinersCoffeeAndPickDB.alignment == "LEFT" then
				if self.previous == 0 then
					btn:SetPoint("LEFT", self.frame, "LEFT", 0, 0);
				else
					btn:SetPoint("LEFT", self.items[self.previous].button, "RIGHT", 2, 0);
				end
			else
				if self.previous == 0 then
					btn:SetPoint("RIGHT", self.frame, "RIGHT", 0, 0);
				else
					btn:SetPoint("RIGHT", self.items[self.previous].button, "LEFT", -2, 0);
				end
			end
			self.previous = num;
			btn.countString:SetText(format("%d",count));
			if buff and buff > 0 then
				btn.buffString:SetText(format("|cff00ff00%d",buff));
			else
				btn.buffString:SetText("");
			end
			btn.texture:SetDesaturated(false);
		elseif count == 0 then
			btn.countString:SetText("");
			btn.texture:SetDesaturated(true);
			btn:Hide();
		end
	else	--Buff is applied
		btn:Hide();
	end
end

function MCAP:createButton(btn,id)
	btn:Hide();
	btn:SetWidth(38);
	btn:SetHeight(38);
	btn:ClearAllPoints();
	btn:SetClampedToScreen(true);
	--Right click to drag
	btn:EnableMouse(true);
	btn:RegisterForDrag("RightButton");
	btn:SetMovable(true);
	btn:SetScript("OnDragStart", function(self) self:GetParent():StartMoving(); end);
	btn:SetScript("OnDragStop", function(self) 
			self:GetParent():StopMovingOrSizing();
			self:GetParent():SetUserPlaced(false);
			local point, relativeTo, relativePoint, xOfs, yOfs = self:GetParent():GetPoint();
			MinersCoffeeAndPickDB.position = {point, nil, relativePoint, xOfs, yOfs};
		end);
	--Setup macro
	btn:SetAttribute("type", "macro");
	btn:SetAttribute("macrotext", format("/use item:%d",id));
	btn.countString = btn:CreateFontString(btn:GetName().."Count", "OVERLAY", "NumberFontNormal");
	btn.countString:SetPoint("BOTTOMRIGHT", btn, -3, 2);
	btn.countString:SetJustifyH("RIGHT");
	btn.buffString = btn:CreateFontString(btn:GetName().."Buff", "OVERLAY", "NumberFontNormal");
	btn.buffString:SetPoint("BOTTOMLEFT", btn, 2, 2);
	btn.buffString:SetJustifyH("LEFT");
	btn.icon = btn:CreateTexture(nil,"BACKGROUND");
	btn.icon:SetTexture(GetItemIcon(id));
	btn.icon:SetAllPoints(btn);
	btn.texture = btn.icon;
	btn.texture:SetPoint("TOPLEFT", btn, -2, 1);
	btn.cooldown = CreateFrame("Cooldown",btn:GetName().."Cooldown", btn, "CooldownFrameTemplate");
	btn.cooldown:SetAllPoints();
	btn.cooldown:Show();
	--Tooltip
	btn:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self,"ANCHOR_TOP");
		GameTooltip:SetItemByID(format("%d",id));
		GameTooltip:SetClampedToScreen(true);
		GameTooltip:Show();
	  end);
	btn:SetScript("OnLeave",GameTooltip_Hide);
 end
 
function MCAP:reset()
	MCAP.frame:ClearAllPoints();
	MCAP.frame:SetPoint('CENTER', UIParent, 'CENTER', 0, 0);
	MinersCoffeeAndPickDB.position = {"CENTER","CENTER",0,0};
	MinersCoffeeAndPickDB.alignment = "LEFT";
	MinersCoffeeAndPickCharacterDB = {
		["keep"] = { ["118897"] = -1,   -- Keep X Miner's Coffee
					 ["118903"] = -1    -- Keep X Preserved Mining Pick
		},
		["buff"] = 5,   -- Buff up to X Miner's Coffee before hiding
		["enable"] = true,   -- Show button
	};
	if MCAP.debug then
		MinersCoffeeAndPickCharacterDB.keep["35954"] = 48;
	end
	MCAP:OnEvent("UPDATE");
end
 
 
function MCAP:OnEvent(event, ...)
	if event == "PLAYER_LOGIN" then
		self.frame:UnregisterEvent("PLAYER_LOGIN");
		MinersCoffeeAndPickDB = MinersCoffeeAndPickDB or {};
		MinersCoffeeAndPickCharacterDB = MinersCoffeeAndPickCharacterDB or {};
		--If DB is empty
		if next (MinersCoffeeAndPickCharacterDB) == nil then
			MCAP:reset();
		end
		if MCAP.debug and MinersCoffeeAndPickCharacterDB.keep["35954"] == nil then
			MinersCoffeeAndPickCharacterDB.keep["35954"] = 48;
		elseif not MCAP.debug and MinersCoffeeAndPickCharacterDB.keep["35954"] then
			MinersCoffeeAndPickCharacterDB.keep["35954"] = nil;
		end
		return
	-- elseif event == "ITEM_LOCK_CHANGED" then
		-- if MCAP.enableSwap then
			-- if MCAP.movesNum > #MCAP.moves then
				-- MCAP.enableSwap = false;
				-- MCAP.isDeleting = false;
			-- else
				-- MCAP.swap();
			-- end
		-- end
		-- return
	end
	--Check for combat to avoid tainting frame
	if UnitAffectingCombat("player") then
		return
	end
	--Only load buttons when player is in their Mine
	--Get localized minimap zone text
	MCAP.buildingID, MCAP.minimap = C_Garrison.GetBuildingInfo(61);
	local zone = GetMinimapZoneText();
	if zone == L["Alliance Mine"] or zone == L["Horde Mine"]
		or zone == MCAP.minimap
		or strlower(zone) == strlower(MCAP.minimap) then
		self.frame:RegisterEvent("LOOT_CLOSED");
		self.frame:RegisterEvent("UNIT_AURA"); 
		self.frame:RegisterEvent("BAG_UPDATE"); 
		--self.frame:RegisterEvent("ITEM_LOCK_CHANGED");
		MCAP.unregisterEvents = true;
		if MinersCoffeeAndPickCharacterDB.enable  then
			self.frame:Show();
		else
			self.frame:Hide();
		end
		self:updateButtons();
	else --Hide anywhere else
		if MCAP.unregisterEvents then
			self.frame:Hide();
			self.frame:UnregisterEvent("LOOT_CLOSED");
			self.frame:UnregisterEvent("UNIT_AURA");
			self.frame:UnregisterEvent("BAG_UPDATE");
			--self.frame:UnregisterEvent("ITEM_LOCK_CHANGED");
			MCAP.unregisterEvents = false;
		end
	end
end

------------------------------------------------
-- Slash Commands
------------------------------------------------
local function slashHandler(msg)
	msg = msg:lower() or "";
	local command, rest = msg:match("^(%S*)%s*(.-)$");
	-- local id = 0;
	-- if command == "coffee" then
		-- id = 118897;
	-- elseif command == "pick" then
		-- id = 118903;
	-- elseif MCAP.debug and command == "milk" then
		-- id = 35954;
	-- end
	-- if id ~= 0 then
		-- if (rest == "all") then
			-- MinersCoffeeAndPickCharacterDB.keep[id..""] = -1;
			-- print("|cffffff78MCAP|r: Keeping |cff33ff99all|r "..select(2,GetItemInfo(id)));
			-- MCAP:updateButtons();
		-- else
			-- local num = tonumber(rest);
			-- if num ~= nil and num >= 0 then
				-- MinersCoffeeAndPickCharacterDB.keep[id..""] = num;
				-- print("|cffffff78MCAP|r: Keeping |cff33ff99"..MinersCoffeeAndPickCharacterDB.keep[id..""].."|r "..select(2,GetItemInfo(id)));
				-- MCAP:updateButtons();
			-- else
				-- print("|cffffff78MCAP|r: Invalid Number Entered: "..rest);
			-- end
		-- end;
	if (command == "buff") then
		local num = tonumber(rest);
		if num ~= nil then
			if num > 5 then
				num = 5;
			end
			if num < 1 then
				num = 1;
			end
			MinersCoffeeAndPickCharacterDB.buff = num;
			print("|cffffff78MCAP|r: Using |cff33ff99"..MinersCoffeeAndPickCharacterDB.buff.."|r stacks of "..select(2,GetItemInfo(118897)));
			MCAP:updateButtons();
		else
			print("|cffffff78MCAP|r: Invalid Number Entered: "..rest);
		end
	elseif (msg == "show" or msg == "enable") then
		MinersCoffeeAndPickCharacterDB.enable = true;
		MCAP:OnEvent("UPDATE");
		print("|cffffff78MCAP|r: Enabled");
	elseif (msg == "hide" or msg == "disable") then
		MinersCoffeeAndPickCharacterDB.enable = false;
		MCAP:OnEvent("UPDATE");
		print("|cffffff78MCAP|r: Disabled");
	elseif (msg == "left") then
		MinersCoffeeAndPickDB.alignment = "LEFT";
		MCAP:updateButtons();
		print("|cffffff78MCAP|r: Buttons aligned to the left");
	elseif (msg == "right") then
		MinersCoffeeAndPickDB.alignment = "RIGHT";
		MCAP:updateButtons();
		print("|cffffff78MCAP|r: Buttons aligned to the right");
	elseif (msg == "reset") then
		MCAP:reset();
		print("|cffffff78MCAP|r: Reset");
	else
		print("|cffffff78MCAP|r: Using |cff33ff99"..MinersCoffeeAndPickCharacterDB.buff.."|r stacks of "..select(2,GetItemInfo(118897)));
		-- if MinersCoffeeAndPickCharacterDB.keep["118897"] == -1 then
			-- print("|cffffff78MCAP|r: Keeping |cff33ff99all|r "..select(2,GetItemInfo(118897)));
		-- else
			-- print("|cffffff78MCAP|r: Keeping |cff33ff99"..MinersCoffeeAndPickCharacterDB.keep["118897"].."|r "..select(2,GetItemInfo(118897)));
		-- end
		-- if MinersCoffeeAndPickCharacterDB.keep["118903"] == -1 then
			-- print("|cffffff78MCAP|r: Keeping |cff33ff99all|r "..select(2,GetItemInfo(118903)));
		-- else
			-- print("|cffffff78MCAP|r: Keeping |cff33ff99"..MinersCoffeeAndPickCharacterDB.keep["118903"].."|r "..select(2,GetItemInfo(118903)));
		-- end 
		print("|cffffff78Miner's Coffee and Pick|r: Arguments to |cffffff78/mcap|r :");
		print("  |cffffff78 show||hide|r - Toggle the buttons.");
		print("  |cffffff78 left||right|r - Set button alignment.");
		print("  |cffffff78 reset|r - Reset all settings.");
		print("  |cffffff78 buff number|r - The number of stacks for "..select(2,GetItemInfo(118897))..".");
		--print("  |cffffff78 coffee number||all|r - The number of "..select(2,GetItemInfo(118897)).." to keep.");
		--print("  |cffffff78 pick number||all|r - The number of "..select(2,GetItemInfo(118903)).." to keep.");
	end
end

SlashCmdList.MinersCoffeAndPick = function(msg) slashHandler(msg) end;
SLASH_MinersCoffeAndPick1 = "/mcap";
SLASH_MinersCoffeAndPick2 = "/minerscoffeeandpick";

--Helper functions
local function cout(msg, premsg)
	premsg = premsg or "[".."Miner's Coffee and Pick".."]"
	print("|cFFE8A317"..premsg.."|r "..msg);
end

local function coutBool(msg,bool)
	if bool then
		print(msg..": true");
	else
		print(msg..": false");
	end
end

--Main Frame
MCAP.frame = CreateFrame("Frame", "MCAP_Frame", UIParent);
MCAP.frame:Hide();
MCAP.frame:SetWidth(76);
MCAP.frame:SetHeight(39);
MCAP.frame:SetClampedToScreen(true);
MCAP.frame:SetFrameStrata("BACKGROUND");
MCAP.frame:SetMovable(true);
MCAP.frame:RegisterEvent("ZONE_CHANGED"); 
MCAP.frame:RegisterEvent("ZONE_CHANGED_INDOORS");
MCAP.frame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
MCAP.frame:RegisterEvent("PLAYER_ENTERING_WORLD");
MCAP.frame:RegisterEvent("PLAYER_REGEN_ENABLED");
MCAP.frame:RegisterEvent("PLAYER_LOGIN");
MCAP.frame:SetScript("OnEvent", function(self,event,...) MCAP:OnEvent(event,...) end);
MCAP.frame:SetScript("OnShow", function(self,event,...) 
	--Restore position
	MCAP.frame:ClearAllPoints();
	if MinersCoffeeAndPickDB and MinersCoffeeAndPickDB.position then
		MCAP.frame:SetPoint(MinersCoffeeAndPickDB.position[1],UIParent,MinersCoffeeAndPickDB.position[3],MinersCoffeeAndPickDB.position[4],MinersCoffeeAndPickDB.position[5]);
	else
		MCAP.frame:SetPoint('CENTER', UIParent, 'CENTER', 0, 0);
	end
 end);
---Create button for each item
for i = 1, #MCAP.items do
	MCAP.items[i].button = CreateFrame("Button", MCAP.items[i].name, MCAP.frame, "SecureActionButtonTemplate,ActionButtonTemplate");
	MCAP:createButton(MCAP.items[i].button,MCAP.items[i].id);
end

------------------------------------------------
-- Interface Options
------------------------------------------------

function MCAP:interfaceOptions_OnShow()
	if not (MCAP.Interface.showButtons == nil) then
		MCAP.Interface.showButtons:SetChecked(MinersCoffeeAndPickCharacterDB.enable);
	end
	MCAP.Interface.buffSlider:SetValue(MinersCoffeeAndPickCharacterDB.buff);
	-- local coffeeNum = MinersCoffeeAndPickCharacterDB.keep["118897"];
	-- local pickNum = MinersCoffeeAndPickCharacterDB.keep["118903"];
	-- if coffeeNum == -1 then
		-- coffeeNum = 101;
	-- end
	-- if pickNum == -1 then
		-- pickNum = 101;
	-- end
	-- MCAP.Interface.coffeeSlider:SetValue(coffeeNum);
	-- MCAP.Interface.pickSlider:SetValue(pickNum);
	MCAP_alignmentDropDownText:SetText("Button Alignment");
end

function MCAP:interfaceOptions_Okay()
	-- local coffeeNum = MCAP.Interface.coffeeSlider:GetValue();
	-- if coffeeNum == 101 then
		-- MinersCoffeeAndPickCharacterDB.keep["118897"] = -1;
	-- else
		-- MinersCoffeeAndPickCharacterDB.keep["118897"] = coffeeNum;
	-- end
	-- local pickNum = MCAP.Interface.pickSlider:GetValue();
	-- if pickNum == 101 then
		-- MinersCoffeeAndPickCharacterDB.keep["118903"] = -1;
	-- else
		-- MinersCoffeeAndPickCharacterDB.keep["118903"] = pickNum;
	-- end
	MCAP:updateButtons();
	--MCAP:OnEvent("UPDATE");
end

function MCAP:interfaceOptions_Cancel()
	--Settings save as they are changed automatically
end

function MCAP:interfaceOptions_Default()
	MCAP:reset();
end

function MCAP:setupInterfaceOptions()
	MCAP.Interface = {};
	MCAP.InterfacePanel = CreateFrame("Frame", "MCAP_InterfacePanel", InterfaceOptionsFramePanelContainer);
	MCAP.InterfacePanel.name = "Miner's Coffee and Pick";
	MCAP.InterfacePanel:Hide();
	MCAP.InterfacePanel.okay = function() MCAP:interfaceOptions_Okay() end
	MCAP.InterfacePanel.cancel = function() MCAP:interfaceOptions_Cancel() end
	MCAP.InterfacePanel.default = function() MCAP:interfaceOptions_Default() end
	MCAP.InterfacePanel:SetScript("OnShow", function(self,event,...) MCAP:interfaceOptions_OnShow(event,...) end);
	
	--Title
	MCAP.Interface.ConfigTitle = MCAP.InterfacePanel:CreateFontString("MCAP_ConfigTitle", "ARTWORK", "GameFontNormalLarge");
    MCAP.Interface.ConfigTitle:SetPoint("TOPLEFT", 16, -16);
    MCAP.Interface.ConfigTitle:SetText("Miner's Coffee and Pick");
	
	--Description
	MCAP.Interface.ConfigSubtitle = MCAP.InterfacePanel:CreateFontString("MCAP_ConfigSubtitle", "ARTWORK", "GameFontHighlight");
    MCAP.Interface.ConfigSubtitle:SetHeight(22);
    MCAP.Interface.ConfigSubtitle:SetPoint("TOPLEFT", MCAP_ConfigTitle, "BOTTOMLEFT", 0, -8);
    MCAP.Interface.ConfigSubtitle:SetPoint("RIGHT", MCAP_InterfacePanel, -32, 0);
    MCAP.Interface.ConfigSubtitle:SetNonSpaceWrap(false);
	MCAP.Interface.ConfigSubtitle:SetWordWrap(true);
    MCAP.Interface.ConfigSubtitle:SetJustifyH("LEFT");
    MCAP.Interface.ConfigSubtitle:SetJustifyV("TOP");
    MCAP.Interface.ConfigSubtitle:SetText("Display Miner's Coffee and Preserved Mining Pick buttons inside your garrison mine.");
	
	--Show Buttons
	MCAP.Interface.showButtons = CreateFrame("CheckButton", "MCAP_showButtons", MCAP.InterfacePanel, "InterfaceOptionsCheckButtonTemplate");
    MCAP.Interface.showButtons:SetPoint("TOPLEFT", MCAP_ConfigSubtitle, "BOTTOMLEFT", 16, -6);
	_G[MCAP.Interface.showButtons:GetName().."Text"]:SetText("Show Buttons");
	MCAP.Interface.showButtons:SetScript("OnClick", function(self, button, down)  
		PlaySound(self:GetChecked() and "igMainMenuOptionCheckBoxOn" or "igMainMenuOptionCheckBoxOff");
		MinersCoffeeAndPickCharacterDB.enable = self:GetChecked();
		MCAP:OnEvent("UPDATE");
		end);
	MCAP.Interface.showButtons.tooltipText = "Show Buttons";
	MCAP.Interface.showButtons.tooltipRequirement = "Show MCAP buttons";
	
	--Buff Slider
	MCAP.Interface.buffSlider = CreateFrame("Slider", "MCAP_buffSlider", MCAP.InterfacePanel, "OptionsSliderTemplate");
	MCAP.Interface.buffSlider:SetWidth(150);
	MCAP.Interface.buffSlider:SetHeight(15);
	MCAP.Interface.buffSlider:SetOrientation('HORIZONTAL');
	MCAP.Interface.buffSlider:SetPoint("TOPLEFT", MCAP_showButtons, "BOTTOMLEFT", 0, -25);
	MCAP.Interface.buffSlider:SetMinMaxValues(1, 5);
	MCAP.Interface.buffSlider.minValue, MCAP.Interface.buffSlider.maxValue = MCAP.Interface.buffSlider:GetMinMaxValues();
	_G[MCAP.Interface.buffSlider:GetName() .. 'Low']:SetText(MCAP.Interface.buffSlider.minValue);
	_G[MCAP.Interface.buffSlider:GetName() .. 'High']:SetText(MCAP.Interface.buffSlider.maxValue);
	_G[MCAP.Interface.buffSlider:GetName() .. 'Text']:SetText('Buff Stack Size');
	MCAP.Interface.buffSlider:SetValueStep(1);
	MCAP.Interface.buffSlider:SetObeyStepOnDrag(true);
	MCAP.Interface.buffSlider:SetScript("OnValueChanged", function(self,value)
			MCAP.Interface.buffEditBox:SetNumber(value);
			MinersCoffeeAndPickCharacterDB.buff = value;
			end);
			
	--Buff Box
	MCAP.Interface.buffEditBox = CreateFrame("EditBox", "MCAP_buffEditBox", MCAP.InterfacePanel, "InputBoxTemplate")
	MCAP.Interface.buffEditBox:SetSize(25, 7);
	MCAP.Interface.buffEditBox:SetPoint("CENTER", MCAP_buffSlider, "CENTER", 0, -22);
	MCAP.Interface.buffEditBox:SetAutoFocus(false);
	MCAP.Interface.buffEditBox:SetNumeric(true);
	MCAP.Interface.buffEditBox:SetJustifyH("CENTER");
	MCAP.Interface.buffEditBox:SetJustifyV("CENTER");
	local filename, fontHeight, flags = MCAP.Interface.buffEditBox:GetFont();
	MCAP.Interface.buffEditBox:SetFont(filename,12,flags);
	MCAP.Interface.buffEditBox:SetScript("OnTextChanged", function(self,userInput)
			if self:GetNumber() > 0 and self:GetNumber() < 6 then
				MinersCoffeeAndPickCharacterDB.buff = self:GetNumber();
				MCAP.Interface.buffSlider:SetValue(MinersCoffeeAndPickCharacterDB.buff);
				MCAP:updateButtons();
			end
			end);
			
	-- --Coffee Slider
	-- MCAP.Interface.coffeeSlider = CreateFrame("Slider", "MCAP_coffeeSlider", MCAP.InterfacePanel, "OptionsSliderTemplate");
	-- MCAP.Interface.coffeeSlider:SetWidth(200);
	-- MCAP.Interface.coffeeSlider:SetHeight(15);
	-- MCAP.Interface.coffeeSlider:SetOrientation('HORIZONTAL');
	-- MCAP.Interface.coffeeSlider:SetPoint("TOPLEFT", MCAP_buffSlider, "BOTTOMLEFT", 0, -45);
	-- MCAP.Interface.coffeeSlider:SetMinMaxValues(1, 101);
	-- MCAP.Interface.coffeeSlider.minValue, MCAP.Interface.coffeeSlider.maxValue = MCAP.Interface.coffeeSlider:GetMinMaxValues();
	-- _G[MCAP.Interface.coffeeSlider:GetName() .. 'Low']:SetText(MCAP.Interface.coffeeSlider.minValue);
	-- _G[MCAP.Interface.coffeeSlider:GetName() .. 'High']:SetText("All");
	-- _G[MCAP.Interface.coffeeSlider:GetName() .. 'Text']:SetText('Quantity of Miner\'s Coffee');
	-- MCAP.Interface.coffeeSlider:SetValueStep(1);
	-- MCAP.Interface.coffeeSlider:SetObeyStepOnDrag(true);
	-- MCAP.Interface.coffeeSlider:SetScript("OnValueChanged", function(self,value)
			-- if value == 101 then
				-- MCAP.Interface.coffeeEditBox:SetText("All");
			-- else
				-- MCAP.Interface.coffeeEditBox:SetText(value.."");
			-- end
			-- end);
			
	-- --Coffee Box
	-- MCAP.Interface.coffeeEditBox = CreateFrame("EditBox", "MCAP_coffeeEditBox", MCAP.InterfacePanel, "InputBoxTemplate")
	-- MCAP.Interface.coffeeEditBox:SetSize(25, 7);
	-- MCAP.Interface.coffeeEditBox:SetPoint("CENTER", MCAP_coffeeSlider, "CENTER", 0, -22);
	-- MCAP.Interface.coffeeEditBox:SetAutoFocus(false);
	-- MCAP.Interface.coffeeEditBox:SetJustifyH("CENTER");
	-- MCAP.Interface.coffeeEditBox:SetJustifyV("CENTER");
	-- local filename, fontHeight, flags = MCAP.Interface.coffeeEditBox:GetFont();
	-- MCAP.Interface.coffeeEditBox:SetFont(filename,12,flags);
	-- MCAP.Interface.coffeeEditBox:SetScript("OnTextChanged", function(self,userInput)
			-- if self:GetText():lower() == "all" then
				-- MCAP.Interface.coffeeSlider:SetValue(101);
			-- else
				-- local num = tonumber(self:GetText());
				-- if num ~= nil then
					-- MCAP.Interface.coffeeSlider:SetValue(num);
				-- end
			-- end
			-- end);	
			
	-- --Pick Slider
	-- MCAP.Interface.pickSlider = CreateFrame("Slider", "MCAP_pickSlider", MCAP.InterfacePanel, "OptionsSliderTemplate");
	-- MCAP.Interface.pickSlider:SetWidth(200);
	-- MCAP.Interface.pickSlider:SetHeight(15);
	-- MCAP.Interface.pickSlider:SetOrientation('HORIZONTAL');
	-- MCAP.Interface.pickSlider:SetPoint("TOPLEFT", MCAP_coffeeSlider, "BOTTOMLEFT", 0, -45);
	-- MCAP.Interface.pickSlider:SetMinMaxValues(1, 101);
	-- MCAP.Interface.pickSlider.minValue, MCAP.Interface.pickSlider.maxValue = MCAP.Interface.pickSlider:GetMinMaxValues();
	-- _G[MCAP.Interface.pickSlider:GetName() .. 'Low']:SetText(MCAP.Interface.pickSlider.minValue);
	-- _G[MCAP.Interface.pickSlider:GetName() .. 'High']:SetText("All");
	-- _G[MCAP.Interface.pickSlider:GetName() .. 'Text']:SetText('Quantity of Preserved Mining Picks');
	-- MCAP.Interface.pickSlider:SetValueStep(1);
	-- MCAP.Interface.pickSlider:SetObeyStepOnDrag(true);
	-- MCAP.Interface.pickSlider:SetScript("OnValueChanged", function(self,value)
			-- if value == 101 then
				-- MCAP.Interface.pickEditBox:SetText("All");
			-- else
				-- MCAP.Interface.pickEditBox:SetText(value.."");
			-- end
			-- end);
			
	-- --Pick Box
	-- MCAP.Interface.pickEditBox = CreateFrame("EditBox", "MCAP_pickEditBox", MCAP.InterfacePanel, "InputBoxTemplate")
	-- MCAP.Interface.pickEditBox:SetSize(25, 7);
	-- MCAP.Interface.pickEditBox:SetPoint("CENTER", MCAP_pickSlider, "CENTER", 0, -22);
	-- MCAP.Interface.pickEditBox:SetAutoFocus(false);
	-- MCAP.Interface.pickEditBox:SetJustifyH("CENTER");
	-- MCAP.Interface.pickEditBox:SetJustifyV("CENTER");
	-- local filename, fontHeight, flags = MCAP.Interface.pickEditBox:GetFont();
	-- MCAP.Interface.pickEditBox:SetFont(filename,12,flags);
	-- MCAP.Interface.pickEditBox:SetScript("OnTextChanged", function(self,userInput)
			-- if self:GetText():lower() == "all" then
				-- MCAP.Interface.pickSlider:SetValue(101);
			-- else
				-- local num = tonumber(self:GetText());
				-- if num ~= nil then
					-- MCAP.Interface.pickSlider:SetValue(num);
				-- end
			-- end
			-- end);
			
	--Alignment
	local info = {};
	MCAP.Interface.alignmentDropDown = CreateFrame("Frame", "MCAP_alignmentDropDown", MCAP.InterfacePanel, "UIDropDownMenuTemplate");
	MCAP.Interface.alignmentDropDown:SetPoint("TOPLEFT", MCAP_buffSlider, "BOTTOMLEFT", -18, -40);
	UIDropDownMenu_SetWidth(MCAP.Interface.alignmentDropDown,140,1);
	MCAP.Interface.alignmentDropDown.initialize = function()
		wipe(info);
		local alignments = {"LEFT", "RIGHT"};
		for i, align in next, alignments do
			info.text = alignments[i];
			info.value = alignments[i];
			info.func = function(self)
				MinersCoffeeAndPickDB.alignment = self:GetText();
				MCAP_alignmentDropDownText:SetText(self:GetText());
				MCAP:updateButtons();
			end
			info.checked = align == MinersCoffeeAndPickDB.alignment;
			UIDropDownMenu_AddButton(info);
		end
	end
	MCAP_alignmentDropDownText:SetText("Button Alignment");
	
	--Reset Settings
	MCAP.Interface.resetUI = CreateFrame("Button", "MCAP_resetUI", MCAP.InterfacePanel, "UIPanelButtonTemplate");
	MCAP.Interface.resetUI:SetText("Reset Settings and Position");
	MCAP.Interface.resetUI:SetWidth(178);
	MCAP.Interface.resetUI:SetHeight(24);
	MCAP.Interface.resetUI:SetPoint("TOPLEFT", MCAP_alignmentDropDown, "BOTTOMLEFT",17,-50);
	MCAP.Interface.resetUI:SetScript("OnClick", function()
		MCAP:reset();
	end);
	MCAP.Interface.resetUI.tooltipText = "Resets all settings to default values";
	
	--Note:
	-- MCAP.Interface.note = MCAP.InterfacePanel:CreateFontString("MCAP_note", "ARTWORK", "GameFontHighlight");
    -- MCAP.Interface.note:SetHeight(18);
    -- MCAP.Interface.note:SetPoint("TOPLEFT", MCAP_resetUI, "BOTTOMLEFT", 0, -50);
    -- MCAP.Interface.note:SetPoint("RIGHT", MCAP_InterfacePanel, -32, 0);
    -- MCAP.Interface.note:SetNonSpaceWrap(false);
	-- MCAP.Interface.note:SetWordWrap(true);
    -- MCAP.Interface.note:SetJustifyH("LEFT");
    -- MCAP.Interface.note:SetJustifyV("TOP");
    -- MCAP.Interface.note:SetText("Press the OKAY button below to save changes.");
	
	InterfaceOptions_AddCategory(MCAP.InterfacePanel);
end

function MCAP:openInterfaceOptions()
	InterfaceOptionsFrame_OpenToCategory(MCAP.InterfacePanel);
end


MCAP:setupInterfaceOptions();
